--- lib-src/gnuclient.c	Fri Sep 04 17:23:06 1998
+++ new-lib-src/gnuclient.c	Fri Sep 04 17:15:55 1998
@@ -179,8 +179,25 @@
 
   fullpath[0] = '\0';
 
-  if (filename[0] && filename[0] != '/')
-    {	/* relative filename */
+  if (filename[0] && filename[0] == '/')
+     {
+       /* Absolute (unix-style) pathname.  Do nothing */
+       strcat (fullpath, filename);
+     }
+#ifdef  __CYGWIN32__
+  else if (filename[0] &&
+           filename[1] && filename[1] == ':' &&
+           filename[2] && filename[2] == '\\')
+    {
+      /* Absolute pathname with drive letter.  Convert drive
+         letter to "//<drive>/". */
+      strcat (fullpath, "//");
+      strncat (fullpath, filename, 1);
+      strcat (fullpath, &filename[2]);
+    }
+#endif
+  else
+    {
       strcat (fullpath, get_current_working_directory ());
       len = strlen (fullpath);
 
@@ -188,10 +205,7 @@
 	;					/* yep */
       else
 	strcat (fullpath, "/");		/* nope, append trailing slash */
-    } /* if */
-
-  strcat (fullpath,filename);
-
+    }
 } /* filename_expand */
 
 /* Encase the string in quotes, escape all the backslashes and quotes
